#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct element{
	struct podaci{char *naziv,*lokacija;
	       int brojzap,kapacitet;} *skladiste;
	struct element *sledeci;
};

#define novipod(x) x=(struct podaci*)malloc(sizeof(struct podaci))
#define novi(x) x=(struct element*)malloc(sizeof(struct element))

void checkpod(struct podaci *p){
	if(p==NULL){
		printf("Greska\n");
		exit(1);
	}
}

void check(struct element *p){
	if(p==NULL){
		printf("Greska\n");
		exit(1);
	}
}

struct element *dodaj(struct element *p,char naziv[],char lokacija[],int brojzap,int kapacitet){
	struct element *pom,*temp;
	struct podaci *skladiste;
	novipod(skladiste);
	checkpod(skladiste);
	novi(temp);
	check(temp);
	skladiste->naziv=strdup(naziv);
	skladiste->lokacija=strdup(lokacija);
	skladiste->brojzap=brojzap;
	skladiste->kapacitet=kapacitet;
	temp->skladiste=skladiste;
	temp->sledeci=NULL;
	if(p==NULL) p=temp;
	else{
		pom=p;
		while(pom->sledeci) pom=pom->sledeci;
		pom->sledeci=temp;
		pom=pom->sledeci;
	}
	return p;
}

void stampaj(struct element *p){
	if(p!=NULL){ do{
		printf("%-15s  %-15s  %-5d  %-5d\n",p->skladiste->naziv,p->skladiste->lokacija,p->skladiste->brojzap,p->skladiste->kapacitet);
		p=p->sledeci;
	}while(p!=NULL);
	printf("\n");
	}
	else printf("Lista je prazna\n");
}

int maksimalni(struct element *p,int x){
	int max=-1;
	if(p!=NULL){ 	
	do{
		if(p->skladiste->brojzap < x)
			if(p->skladiste->kapacitet > max) max=p->skladiste->kapacitet;
		p=p->sledeci;
	}while(p!=NULL);
	printf("\n");
	}
	else printf("Lista je prazna\n");
	return max;
}

struct element *brisi(struct element *p,char naziv[]){
	struct element *pom,*pom2;	
	pom=p;	
	if(pom==NULL) return NULL;
	else{
		if(strcmp(pom->skladiste->naziv,naziv)==0){
			while(pom && strcmp(pom->skladiste->naziv,naziv)==0){
				pom2=pom->sledeci;
				free(pom);
				pom=pom2;
			}
			if(pom) pom->sledeci=brisi(pom->sledeci,naziv); else return NULL;//return pom2;
		}
		else pom->sledeci=brisi(pom->sledeci,naziv);
	}
	return pom;
}
			

int main(){
	struct element *glava;
	int n,brojzap,kapacitet,maxkap,maxzap;
	char naziv[50],lokacija[50];	

	glava=NULL;
	printf("Unesi n: "); scanf("%d",&n);
	while(n--){
		printf("Naziv: "); scanf("%s",naziv);
		printf("Lokacija: "); scanf("%s",lokacija);
		printf("Broj zaposlenih: "); scanf("%d",&brojzap);
		printf("Kapacitet: "); scanf("%d",&kapacitet);
		printf("\n");
		glava=dodaj(glava,naziv,lokacija,brojzap,kapacitet);
	}
	stampaj(glava);
	
	printf("Daj broj zaposlenih: "); scanf("%d",&maxzap);	
	maxkap=maksimalni(glava,maxzap);
	if(maxkap>-1) printf("Maksimalni kapacitet je %d\n",maxkap);
	else printf("Nema manjih od %d/lista je prazna\n",maxzap);
	
	printf("\nLista pre brisanja:\n\n");
	stampaj(glava);
	printf("Koji da obrisem: "); scanf("%s",naziv);
	glava=brisi(glava,naziv);
	printf("\n");	
	stampaj(glava);

}

