#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct node {
	char *rec;
	struct node *levi,*desni;
	int balans;
};

#define novi(x) x=(struct node *)malloc(sizeof(struct node))

int dubina(struct node *);
struct node *form();
int dodaj(struct node **,char *);
void drotacija(struct node **);
void lrotacija(struct node **);
int dubina(struct node *);
void ispis(struct node *);
struct node *nadji(struct node *,char *,struct node **);
struct node *brisi(struct node *,char *);
struct node *vdmvl(struct node *);

int main(int argc,char *argv[]){
struct node *p=NULL,*r,*x;

if(argc<1) {printf("Nisi uneo rec za brisanje");exit(1);}

p=form();
ispis(p);
putchar('\n');
x=vdmvl(p);

printf("\nKoren je %s\n",p->rec);
if(x==NULL) printf("Takva rec ne postoji\n");
	else printf("Minimalna rec je %s",x->rec);

putchar('\n');
p=brisi(p,argv[1]);
ispis(p);
putchar('\n');
return 0;
}

struct node *form(){
	struct node *p=NULL;
	char text[15];

	scanf("%s",&text);
	while(strcmp(text,"kraj")!=0){
		dodaj(&p,text);
		scanf("%s",&text);
	}
return p;
}

int dodaj(struct node **p,char *text){
	struct node *temp;
	int inkrement,rezultat=0;
	temp=*p;

	if(temp==NULL){
		novi(temp);
		if(temp==NULL)	{printf("Nema mesta za alociranje memorije\n");exit(1);}
		temp->balans=0;
		temp->levi=temp->desni=NULL;
		temp->rec=(char*)malloc(strlen(text));
		strcpy(temp->rec,text);
		rezultat=1;
	}
	else{
	if(strcmp(text,temp->rec)<0) inkrement=-dodaj(&(temp->levi),text);
	else inkrement=dodaj(&(temp->desni),text);
	temp->balans+=inkrement;

	if((temp->balans!=0)&&(inkrement!=0)){
		if(temp->balans<-1){
			if(temp->levi->balans<0) drotacija(&temp);
			else {lrotacija(&(temp->levi));drotacija(&temp);}
		}
		else if(temp->balans>1){
			if(temp->desni->balans>0) lrotacija(&temp);
			else {drotacija(&(temp->desni));lrotacija(&temp);}
		}
		else rezultat=1;
	}
	}
*p=temp;
return rezultat;
}

void drotacija(struct node **p){
	struct node *poml,*pomd;

pomd=*p;
poml=pomd->levi;
pomd->levi=poml->desni;
poml->desni=pomd;
*p=poml;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);

}

void lrotacija(struct node **p){
	struct node *poml,*pomd;

poml=*p;
pomd=poml->desni;
poml->desni=pomd->levi;
pomd->levi=poml;
*p=pomd;
poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dubina(struct node *p){
	int dl,dd;
	dl=dd=0;
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
	
	if(dl>dd) return ++dl;
	else return ++dd;
	}
	return 0;
}
void ispis(struct node *p){
	if(p){
	printf("(");
	if(p->desni) ispis(p->desni);
	printf(" %s(%d) ",p->rec,p->balans);
	if(p->levi) ispis(p->levi);	
	printf(")");
	}
}

struct node *nadji(struct node *p,char *text,struct node **r){
	struct node *x;
	if(p==NULL) return NULL;
	x=p;
	*r=NULL;
	while(x){
		if(strcmp(text,x->rec)==0) return x;
		else{
			*r=x;
			if(strcmp(text,x->rec)<0) x=x->levi;
			else x=x->desni;
		}
	}
return NULL;
}

struct node *brisi(struct node *p,char *text){
	struct node *x,*y,*pom,*q;
	x=nadji(p,text,&y);
	if(x==NULL) {printf("\nNema trazene reci\n");exit(1);}
	
	if(!(x->levi)&&!(x->desni)) q=NULL;
	if(!(x->levi)&&(x->desni)) q=x->desni;
	if((x->levi)&&!(x->desni)) q=x->levi;
	if((x->levi)&&(x->desni)) {
	pom=x->desni;
	while(pom->levi) pom=pom->levi;
	pom->levi=x->levi;
	q=x->desni;
	}
	if(!y) p=q;
	else {
		if(x==y->levi) y->levi=q;
		else y->desni=q;
	}
return p;
}

struct node *vdmvl(struct node *p){
	struct node *pom1,*pom2;
	if(p==NULL) exit(1);

	pom1=p;
	pom2=NULL;
	while((pom1) && (pom2==NULL)){
		if(pom1->balans>0) pom2=pom1;
		pom1=pom1->levi;
	}
	printf("\nPrva rec je %s\n",pom2->rec);
	/*ovde imamo prvi cvor ciji je balans pozitivan i to je pom2*/
	pom1=p;
	while(pom1){
		if((pom1->balans>0) && (strcmp(pom1->rec,pom2->rec)<0)) pom2=pom1;
		pom1=pom1->levi;
	}
	return pom2;
}
