#include <stdio.h>
#include <string.h>
#include <stdlib.h>

enum { CRNA, CRVENA };

struct drvo{
  int broj, boja;
  struct drvo *roditelj, *levi ,*desni;
};

void lrotacija(struct drvo **p){
  struct drvo *l, *d;
  l=*p;
  d=l->desni;
  l->desni=d->levi;
  if(d->levi) d->levi->roditelj=l;
  if(l->roditelj)
    if(l==l->roditelj->levi) l->roditelj->levi=d;
    else l->roditelj->desni=d;
  d->roditelj=l->roditelj;
  l->roditelj=d;
  d->levi=l;
  *p=d;
}

void drotacija(struct drvo **p){
  struct drvo *l, *d;
  d=*p;
  l=d->levi;
  d->levi=l->desni;
  if(d->desni) d->desni->roditelj=l;
  if(d->roditelj)
    if(d==d->roditelj->levi) d->roditelj->levi=l;
    else d->roditelj->desni=l;
  l->roditelj=d->roditelj;
  d->roditelj=l;
  l->desni=d;
  *p=l;
}

void bojefix(struct drvo **p, struct drvo *z){
  struct drvo *y, *t;
  while(z->roditelj && z->roditelj->boja==CRVENA){
    if(z->roditelj->roditelj){
      if(z->roditelj==z->roditelj->roditelj->levi){
        y=z->roditelj->roditelj->desni;
        if(y && y->boja==CRVENA){
          z->roditelj->boja=CRNA;
          y->boja=CRNA;
          z=z->roditelj->roditelj;
          z->boja=CRVENA;
        }
        else{
           if(z==z->roditelj->desni){
             z=z->roditelj;
             lrotacija(&z);
             if(!z->roditelj) *p=z;
             z=z->levi;
           }
           z->roditelj->boja=CRNA;
           t=z->roditelj->roditelj;
           t->boja=CRVENA;
           drotacija(&t);
           if(!t->roditelj) *p=t;  
        }
      }
      else{
        y=z->roditelj->roditelj->levi;
        if(y && y->boja==CRVENA){
          z->roditelj->boja=CRNA;
          y->boja=CRNA;
          z=z->roditelj->roditelj;
          z->boja=CRVENA;                                 
        }
        else{
          if(z==z->roditelj->levi){
            z=z->roditelj;
            drotacija(&z);
            if(!z->roditelj) *p=z;
            z=z->desni;
          }
          z->roditelj->boja=CRNA;
          t=z->roditelj->roditelj;
          t->boja=CRVENA;
          lrotacija(&t);
          if(!t->roditelj) *p=t;
        }
      }
    }
    else break;
  }
  (*p)->boja=CRNA;
}

void dodaj(struct drvo **p, int k){
  struct drvo *t, *x=*p, *y=NULL;
  t=(struct drvo *)malloc(sizeof(struct drvo));
  if(!t) exit(0);
  t->broj=k;
  t->levi=t->desni=NULL;
  if(x==NULL){
    t->boja=CRNA;
    t->roditelj=NULL;
    *p=t;
  }
  else{
    t->boja=CRVENA;
    while(x){
      y=x;
      if(x->broj>k) x=x->levi;
      else x=x->desni;
    }
    t->roditelj=y;
    if(y->broj>k) y->levi=t;
    else y->desni=t;
    bojefix(p,t);
  }
}

struct drvo *form(void){
  struct drvo *koren=NULL;
  int n,i,k;
  scanf("%d",&n);
  for(i=0;i<n;i++){
    scanf("%d",&k);
    dodaj(&koren,k);
  }
  return koren;
}

void ispis(struct drvo *p){
  if(p){
    printf("(");
    ispis(p->levi);
    printf("%d->",p->broj);
    if(p->boja==CRNA) printf("CRNA\n");
    else printf("CRVENA");
    ispis(p->desni);
    printf(")\n");
  }
}

int najcrnji(struct drvo *p, int min){
  int l,d;
  if(p){
    if(p->boja==CRNA && p->broj<min) min=p->broj;
    l=najcrnji(p->levi,min);
    d=najcrnji(p->desni,min);
    if(d>l) min=l;
    else min=d;
  }
  return min;
}

main(){
  struct drvo *koren=NULL;
  int min;
  koren=form();
  ispis(koren);
  min=koren->broj;
  printf("Najmanji crni je %d\n",najcrnji(koren,min));
}